package demo
{
    import flash.display.Graphics;
    import flash.events.MouseEvent;
    
    import mx.core.UIComponent;
    
    public class DrawCanvas extends UIComponent
    {
        private var _color:uint;
        
        public function get color():uint{
            return _color;
        }
        
        public function set color(value:uint):void{
            if( _color != value ){
                _color = value;
                invalidateDisplayList();
            }
        }
        
        private var button1:RectButton;
        
        private var button2:RectButton;
        
        protected override function createChildren():void{
            log(this,"#createChildren");
            button1 = new RectButton();
            button1.name = "button1";
//            button1.width = 25;
//            button1.height = 25;
            addChild(button1);            

            button2 = new RectButton();
            button2.name = "button2";
//            button2.y = 30;
//            button2.color = 0xFF0000;
//            button2.width = 25;
//            button2.height = 25;
            addChild(button2);            
        }
        
        protected override function commitProperties():void{
            log(this,"#commitProperties");
            button1.width = 25;
            button1.height = 25;
            button2.width = 25;
            button2.height = 25;

            button2.color = 0xFF0000;            
        }
        
        protected override function measure():void{
            log(this,"#measure");
        }
        
        protected override function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void{
            log(this,"#updateDisplayList("+unscaledWidth+","+unscaledHeight+")");
            var g:Graphics = this.graphics;
            g.clear();
            g.beginFill(color);
            g.drawRect(0,0,unscaledWidth,unscaledHeight);
            g.endFill();
            
            button1.setActualSize(
                button1.getExplicitOrMeasuredWidth(),
                button1.getExplicitOrMeasuredHeight()
                );

            button2.setActualSize(
                button2.getExplicitOrMeasuredWidth(),
                button2.getExplicitOrMeasuredHeight()
                );
            button2.move(0,30);                
        }

    }
}