package
{
    import flash.events.Event;
    import flash.events.TextEvent;
    import flash.text.TextLineMetrics;
    
    import mx.containers.Panel;
    
    public class AdjustTextAreaPanel extends Panel
    {
        public var textArea:TextAreaEx;
        
        private var isLineChanged:Boolean;

        private var firstLineH:int;
        
        private var lastLine:int = 1;
        
        private function textChangeHandler( event:Event ):void{
        	if( textArea.numLines != lastLine ){
        		isLineChanged = true;
        	}
        	invalidateSize();
        	invalidateProperties();
            invalidateDisplayList();
        }        
        
        protected override function createChildren():void{
        	log(this,"createChildren");
            super.createChildren();
            textArea = new TextAreaEx();
            textArea.percentWidth = 100;
            textArea.percentHeight = 100;
            textArea.addEventListener(Event.CHANGE,textChangeHandler);
            addChild(textArea);

            var m:TextLineMetrics = textArea.getLineMetrics(0);
            firstLineH = m.height;
        }
        
        protected override function commitProperties():void{
            log(this,"commitProperties");
            if( isLineChanged ){
            	isLineChanged = false;
            	var divLine:int = textArea.numLines - lastLine;
	            if( divLine > 0 ){
            		setActualSize(width,height+firstLineH);
	            } else {
            		setActualSize(width,height-firstLineH);
	            }
	            lastLine = textArea.numLines;
            }
            super.commitProperties();
        }
    }
}